/*
  Copyright 2010-2011 Grégory Soutadé

  This file is part of KissCount.

  KissCount is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  KissCount is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with KissCount.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef CALENDAREDITOR_H
#define CALENDAREDITOR_H

#include <wx/wx.h>
#include <wx/grid.h>
#include <wx/calctrl.h>
#include <wx/datetime.h>
#include <wx/event.h>
#include <wx/choice.h>

class CalendarEditor : public wxGridCellChoiceEditor, public wxEvtHandler
{
public:
  
    CalendarEditor(int day, int month, int year);
    ~CalendarEditor();

    void BeginEdit(int row, int col, wxGrid *grid);
    wxGridCellEditor* Clone () const;
    void Create(wxWindow *parent, wxWindowID id, wxEvtHandler *evtHandler);
    bool EndEdit(int row, int col, wxGrid *grid);
    void ApplyEdit(int row, int col, wxGrid *grid);
    wxString GetValue() const;
    void Reset();
    void Show(bool show, wxGridCellAttr *attr=NULL);
    void SetSize (const wxRect &rect);
    /* void OnCalendarChange(wxCommandEvent& event); */
    void OnDateChanged(wxCommandEvent& event);
    void StartingClick();
    bool IsAcceptedKey(wxKeyEvent &event);
  
private:
    int _day;
    int _month;
    int _year;
    wxWindow *_parent;
    wxString* _days;
    int _maxDay;
    wxChoice* _editor;
};

#endif
